VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsArgs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Classe de gestion des arguments de la ligne de commande
'
' Chaque argument est dclar par un "/" suivi d'une lettre
' dsignant sa fonction. Si un "/" se trouve  l'intrieur de guillemets,
' il n'est pas pris en compte, on considre cela comme un chemin de fichier.
' Les espaces ne sont pas pris en compte comme sparateurs d'arguments,
' c'est  dire que /a/b/c quivaut bien  3 paramtres.

Option Explicit
' Dfinit le dlimiteur de chane (ici le guillemet)
' Permet de traiter /x="toto /a /b /c" /y comme 2 arguments seulement /x et /y
Private Const DELIMITE_CHAINE = """"
' Caractre de dfinition d'option
Private Const CAR_ARGUMENT = "/"
' Pas de distinctions entre majuscule et minuscule pour les arguments
Private Const DIFF_MAJ_MIN = False
' Ligne de commande
Private mst_Commande As String
' Nombre d'arguments sur la ligne de commande
Private mlg_Args As Long
Public Function ValeurOption(stOption As String) As String
Dim lgFor As Long, lgForIn As Long, lgLen As Long, lgCmd As Long
Dim blTmp As Boolean
Dim stTmp As String
' Vrifie si le caractre de dfinition d'argument est donn, si on le met
If Left$(stOption, 1) <> CAR_ARGUMENT Then stOption = CAR_ARGUMENT & stOption
stTmp = vbNullString
' Recherche si l'option existe sur la ligne de commande
If ExisteOption(stOption) Then
    blTmp = False
    lgLen = Len(stOption)
' Positionne le pointeur courant au dpart de l'option
    For lgFor = 1 To Len(mst_Commande) - lgLen
        If (Mid$(mst_Commande, lgFor, 1) = DELIMITE_CHAINE) Then blTmp = Not blTmp
        If Not blTmp Then
            If DIFF_MAJ_MIN Then
                If Mid$(mst_Commande, lgFor, lgLen) = stOption Then Exit For
            Else
                If UCase$(Mid$(mst_Commande, lgFor, lgLen)) = UCase$(stOption) Then Exit For
            End If
        End If
    Next lgFor
    lgCmd = Len(mst_Commande)
    blTmp = False
    lgFor = lgFor + lgLen
' Rcupre la valeur associe  l'option choisie
    Do While lgFor <= Len(mst_Commande)
' Permet de rcuprer les chemins de fichiers entre guillemets
        If (Mid$(mst_Commande, lgFor, 1) = DELIMITE_CHAINE) Then blTmp = Not blTmp
        If Not blTmp Then
' Sort ds que l'option suivante est rencontre
            If (Mid$(mst_Commande, lgFor, 1) = "/") Then Exit Do
        End If
        stTmp = stTmp & Mid$(mst_Commande, lgFor, 1)
        lgFor = lgFor + 1
    Loop
    stTmp = Trim$(stTmp)
' Suppression du guillemet au dbut et  la fin (seulement s'il y en a un au dbut)
    If Left$(stTmp, 1) = DELIMITE_CHAINE Then stTmp = Mid$(stTmp, 2, Len(stTmp) - 2)
End If
ValeurOption = stTmp
End Function
Public Function ExisteOption(stOption As String) As Boolean
Dim lgFor As Long, lgLen As Long
Dim blTmp As Boolean, blExiste As Boolean
' Vrifie si le caractre de dfinition d'argument est donn, si on le met
If Left$(stOption, 1) <> CAR_ARGUMENT Then stOption = CAR_ARGUMENT & stOption
lgLen = Len(stOption)
blTmp = False
If DIFF_MAJ_MIN Then
    blExiste = (mst_Commande = stOption)
Else
    blExiste = (UCase$(mst_Commande) = UCase$(stOption))
End If
For lgFor = 1 To Len(mst_Commande) - lgLen
' Saute les guillemets qui peuvent encadrer un nom de fichier long contenant des espaces
    If (Mid$(mst_Commande, lgFor, 1) = DELIMITE_CHAINE) Then blTmp = Not blTmp
    If Not blTmp Then
        ' Gestion des majuscules/minuscules sur les arguments
        If DIFF_MAJ_MIN Then
            If Mid$(mst_Commande, lgFor, lgLen) = stOption Then
                blExiste = True
                Exit For
            End If
        Else
            If UCase$(Mid$(mst_Commande, lgFor, lgLen)) = UCase$(stOption) Then
                blExiste = True
                Exit For
            End If
        End If
    End If
Next lgFor
ExisteOption = blExiste
End Function
Public Function CompteArgs() As Long
' Permet de compter le nombre d'arguments sur la ligne de commande
Dim lgFor As Long, lgLen As Long
Dim blTmp As Boolean
' Regarde si on a dj fait le travail ...
If mlg_Args < 0 Then
' ... sinon, on traite la ligne de commande.
    blTmp = False
    mlg_Args = 0
    For lgFor = 1 To Len(mst_Commande)
    ' Saute les guillemets qui peuvent encadrer un nom de fichier long contenant des espaces
        If (Mid$(mst_Commande, lgFor, 1) = DELIMITE_CHAINE) Then blTmp = Not blTmp
        If Not blTmp Then
        ' Si on ne se trouve pas  l'intrieur de guillement, on incrmente le nombre d'argument
            If Mid$(mst_Commande, lgFor, 1) = CAR_ARGUMENT Then mlg_Args = mlg_Args + 1
        End If
    Next lgFor
End If
CompteArgs = mlg_Args
End Function
Public Property Let Commande(ByVal vData As String)
' Raffecte la valeur de la ligne de commande
mst_Commande = vData
' Rinitialise le nombre d'argument
mlg_Args = -1
End Property
Public Property Get Commande() As String
' Retourne la ligne de commande
Commande = mst_Commande
End Property
Private Sub Class_Initialize()
' Rcupration de la ligne de commande envoye  l'application
mst_Commande = Command()
' Initialisation du nombre d'argument
mlg_Args = -1
End Sub
